importScripts('../libraries/moo.js', '../libraries/language.js', '../shared worker.js')

var names = ['Ашот', 'Гиви', 'Арен', 'Магомед', 'Гурген', 'Джафар', 'Равзан', 'Хачатур', 'Возген', 'Ара']
var name = names[Math.floor(Math.random() * 10)]
		
var webSocket

Shared_worker.new(self, 
{
	ready: function()
	{
		var worker = this
		
		worker.broadcast('name', name)

		if (!webSocket)
		{
			webSocket = new WebSocket('ws://localhost:8888/')
			
			webSocket.onopen = function(event) 
			{
				webSocket.send(JSON.stringify({ type: 'authenticate', user: name, password: 123 }))
			}
			
			webSocket.onclose = function(message) 
			{
				worker.broadcast('closed')
			}

			webSocket.onmessage = function(message) 
			{
				var message = JSON.parse(message.data)

				switch (message.type)
				{
					case 'authenticated':
						// вход выполнен
						break
						
					case 'message':
						worker.broadcast('message', message)
						break
				}
			}
		}
	}
})