var texts = 
[
	'В начале сотвори бог небо и землю. ',
	'Земля же бе невидима и неустроена, и тма верху бездны, и дух божий ношашеся верху воды. ',
	'И рече бог: да будет свет. И бысть свет. ',
	'И виде бог свет, яко добро, и разлучи бог между светом и между тмою. ',
	'И нарече бог свет [день], а тму нарече [нощь]. И бысть вечер, и бысть утро, день един. ',
	'И рече бог: да будет твердь посреде воды, и да будет разлучающи посреде воды и воды. И бысть тако. ',
	'И сотвори бог твердь, и разлучи бог между водою, яже бе под твердию, и между водою, яже бе над твердию. ',
	'И нарече бог твердь [небо]. И виде бог, яко добро. И бысть вечер, и бысть утро, день вторый. ',
	'И рече бог: да соберется вода, яже подъ небесем, в собрание едино, и да явится суша. И бысть тако. И собрася вода, яже подъ небесем, в собрания своя, и явися суша. ',
	'И нарече бог сушу [землю], и собрания вод нарече [моря]. И виде бог, яко добро. '
]

// npm install ws
var WebSocketServer = require('ws').Server
var server = new WebSocketServer({ port: 8888 })

server.on('connection', function(socket) 
{
	var loop

	socket.on('close', function() 
	{
		if (loop)
			clearInterval(loop)
	})

	socket.on('message', function(message) 
	{
		message = JSON.parse(message)
		
		switch (message.type)
		{
			case 'authenticate':
				if (message.password == 123)
				{
					loop = setInterval(function()
					{
						socket.send(JSON.stringify({ type: 'message', sender: 'Викентий', text: texts[Math.floor(Math.random() * 10)] }))
					},
					2000)
				}
				break
		}
	})
})